﻿

Public Class Form1
    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'My sound files use compression, so this is an array with a length of 256 (each entry represents a byte).
        'Essentially, if it has a value of 1, it will compress the byte to 4-bits, if it has a value of 2, the byte with be "compressed" into 8-bits,
        '   and if it has a value of 3, it will be "compressed" into 12 bits. This is used later.
        Dim CompressedType() = { _
         &H1, &H2, &H3, &H3, &H2, &H2, &H2, &H3, &H3, &H3, &H2, &H3, _
         &H3, &H3, &H3, &H3, &H2, &H2, &H3, &H3, &H2, &H2, &H2, &H3, _
         &H3, &H2, &H2, &H2, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H2, &H2, &H2, &H3, &H2, &H2, &H2, &H3, _
         &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H2, &H2, &H3, &H3, _
         &H2, &H1, &H1, &H3, &H3, &H2, &H1, &H2, &H3, &H3, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H2, &H2, &H2, &H3, &H2, &H2, &H1, &H2, _
         &H3, &H3, &H2, &H2, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H2, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, _
         &H2, &H2, &H3, &H3, &H2, &H1, &H1, &H3, &H3, &H2, &H2, &H2, _
         &H3, &H3, &H3, &H3, &H2, &H3, &H3, &H3, &H2, &H1, &H2, &H3, _
         &H3, &H1, &H1, &H2, &H3, &H3, &H2, &H2, &H3, &H3, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H3, &H2, &H2, &H2, &H3, &H2, &H2, &H2, _
         &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, _
         &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, &H3, _
         &H2, &H2, &H2, &H3, &H3, &H2, &H2, &H2, &H3, &H3, &H2, &H2, _
         &H3, &H3, &H3, &H3, &H3, &H2, &H3, &H3, &H3, &H2, &H2, &H2, _
         &H3, &H3, &H2, &H1 _
        }
        'Setup up a pop-up box prompting you to use a wav file
        Dim OpeningDialog As New OpenFileDialog()
        OpeningDialog.AddExtension = True
        OpeningDialog.AutoUpgradeEnabled = True
        OpeningDialog.CheckFileExists = True
        OpeningDialog.CheckPathExists = True
        OpeningDialog.Filter = "Wave Files|*.wav"
        OpeningDialog.ShowHelp = False
        OpeningDialog.ValidateNames = True
        OpeningDialog.Multiselect = False
        If (OpeningDialog.ShowDialog() <> Windows.Forms.DialogResult.OK) Then
            Me.Close()  'The person clicked cancel. Quit.
            Return
        End If
        Dim BO
        'Visual Basic has issues when it deals with files that use bytes containing the value &H0, so essentially this Class converts files into an array for use.
        BO = New ClsBin
        'Convert the song selected by the user into an array
        Dim WaveFile() As Object = BO.GetArray(BO.Read(OpeningDialog.FileName))


        Dim i, j, k, l
        'Basically, if any of these bytes in the wave file are not equal to this, then the file is not a wave file... so quit (basically the identifying header)
        If ((WaveFile(0) <> &H52) Or (WaveFile(1) <> &H49) Or (WaveFile(2) <> &H46) Or (WaveFile(3) <> &H46) Or (WaveFile(8) <> &H57) Or (WaveFile(9) <> &H41) Or (WaveFile(10) <> &H56) Or (WaveFile(11) <> &H45) Or (WaveFile(12) <> &H66) Or (WaveFile(13) <> &H6D) Or (WaveFile(14) <> &H74) Or (WaveFile(15) <> &H20)) Then
            MsgBox("This is not recognized as a valid .wav file!")
            Me.Close()
            Return
        End If
        i = 0
        'Search through the array until we find the first occurance of the following four hex values (making "data"). This identifies the beginning of the data section
        'Note that the program does NOT make sure that the wave file is 8.000 kHz, 8-bit, mono, PCM, so it will give wrong results if it isn't properly formatted
        While i < WaveFile.Length - 4
            i += 1
            If ((WaveFile(i) = &H64) And (WaveFile(i + 1) = &H61) And (WaveFile(i + 2) = &H74) And (WaveFile(i + 3) = &H61)) Then
                Exit While
            End If
        End While
        i += 4
        'The four bytes after "data" represent the size of the data section
        Dim DataSize = WaveFile(i) + WaveFile(i + 1) * 256 + WaveFile(i + 2) * 256 * 256 + WaveFile(i + 3) * 256 * 256 * 256
        i += 4
        'DataStart is the beginning of the real data of the song - when I convert it I will be using this as an offset
        Dim DataStart = i
        i = 0   'This serves no use - it's because I changed the code around (the i+=4s could also be integrated into their nearby lines) - told ya I was inefficient with VB
        'Finala is the contents of the AppVar I'm going to make.
        Dim Finala(76 + 16)
        'This is the identifier for my AppVar
        Finala(0) = Asc("G")
        Finala(1) = Asc("U")
        Finala(2) = Asc("I")
        Finala(3) = Asc("T")
        Finala(4) = Asc("C")
        Finala(5) = Asc("A")
        Finala(6) = Asc("L")
        Finala(7) = Asc("C")
SongName:
        'Prompt the user for a songname
        Dim TempResponse = InputBox("What is the song name? (max 16 characters)").ToCharArray
        If (TempResponse.Length > 16) Then
            MsgBox("Too long!")
            GoTo SongName
        End If
        'Convert the answer into their ascii code and save that for 8-23 in my AppVar
        For i = 0 To TempResponse.GetUpperBound(0)
            Finala(i + 8) = Asc(TempResponse(i))
        Next
        'Pad the remaining characters with spaces.
        While i < 17
            Finala(i + 8) = Asc(" ")
            i += 1
        End While
BandName:
        'Same thing with bandname - 24-39
        TempResponse = InputBox("What is the band name? (max 16 characters)").ToCharArray
        If (TempResponse.Length > 16) Then
            MsgBox("Too long!")
            GoTo BandName
        End If
        For i = 0 To TempResponse.GetUpperBound(0)
            Finala(24 + i) = Asc(TempResponse(i))
        Next
        While i < 17
            Finala(24 + i) = Asc(" ")
            i += 1
        End While
TimeName:
        'Store the time - the person is supposed to write it in X:XX format but they can really input any 4 characters here
        TempResponse = InputBox("How long is the song?? (4 characters, X:XX)", "", "0:00").ToCharArray
        If (TempResponse.Length > 4) Then
            MsgBox("Invalid!")
            GoTo TimeName
        End If
        For i = 0 To TempResponse.GetUpperBound(0)
            Finala(40 + i) = Asc(TempResponse(i))
        Next
        While i < 5
            Finala(40 + i) = Asc(" ")
            i += 1
        End While

BadName:
        'Asked for an AppVar name. I require it to be 7 characters long because the 8th character is used for numbering,
        '   and I didn't feel like facing the complications of padding the AppVar name (since it's more complicated, of course).
        Dim Named2 As String = InputBox("What name would you like to give to your AppVar?", "Name")
        'Named2 is the AppVar in string form
        'Named is the AppVar in char() form.
        Dim Named As Char() = Named2.ToCharArray()
        If (Named.Length = 0) Then
            If (MsgBox("You must enter a name!", 1) = vbOK) Then
                GoTo BadName
            End If
            'If they don't write a name, then click Cancel/No when it says you must enter a name - Quit. This should also exist when prompting for Time/BandName/SongName, but it doesn't.
            Me.Close()
            Return
        End If
        If (Named.Length <> 7) Then
            If (MsgBox("The name entered must be 7 characters long!", 1) = vbOK) Then
                GoTo BadName
            End If
            Me.Close()
            Return
        End If
        'Guessing that the calculator might have problems with invalid characters, so only accepting Letters, Digits, and spaces.
        For i = 0 To Named.GetUpperBound(0)
            If (Not (Char.IsLetterOrDigit(Named(i)) Or Named(i) = " "c)) Then
                MsgBox(Named(i) + " is not a valid symbol! Only letters of the alphabet or numbers are accepted!", 1)
                GoTo BadName
            End If
        Next

        'I am padding the highscores table with 0s
        For i = &H32 To &H39
            Finala(i) = &H20
        Next
        For i = &H40 To &H47
            Finala(i) = &H20
        Next
        For i = &H4E To &H55
            Finala(i) = &H20
        Next
        'And the name of the person to make the highscore with spaces
        For i = &H3A To &H3F
            Finala(i) = &H30
        Next
        For i = &H48 To &H4D
            Finala(i) = &H30
        Next
        For i = &H56 To &H5B
            Finala(i) = &H30
        Next
        ReDim Preserve Named(7) 'Allow for an 8th character in the char array (for numbering)
        i = 0       'This is a counter for the # of AppVar sound files
        j = True    'I am compressing the song data into sets of 4-bits, so j is False when the last byte in the file has only 4 bits filled up
        k = 0       'This is a counter for how far into the data of the wav file I am
        While (0 = 0)   'Loop until I tell it to stop.
            'Add 8 bytes to the end of Finala
            ReDim Preserve Finala(Finala.GetUpperBound(0) + 8)
            'Write the name of the AppVar containing the song (there are several of these, so every time one is made, we add another 8 bytes
            '   and write down the next AppVar
            i += 1  'This is the nth AppVar
            Named(7) = Chr(Asc("A") - 1 + i)    'The AppVar sound files are "numbered" alphabetically
            Finala(&H5D - 8 + i * 8) = Asc(Named(0))
            Finala(&H5D - 8 + i * 8 + 1) = Asc(Named(1))
            Finala(&H5D - 8 + i * 8 + 2) = Asc(Named(2))
            Finala(&H5D - 8 + i * 8 + 3) = Asc(Named(3))
            Finala(&H5D - 8 + i * 8 + 4) = Asc(Named(4))
            Finala(&H5D - 8 + i * 8 + 5) = Asc(Named(5))
            Finala(&H5D - 8 + i * 8 + 6) = Asc(Named(6))
            Finala(&H5D - 8 + i * 8 + 7) = Asc(Named(7))
            'While Finala is the AppVar for the information, Finalx is the AppVar for the song itself
            Dim Finalx(-1)  'Make it 0-length
            'ReDim Preserve Finalx(Finalx.GetUpperBound(0) + 1)
            While ((Finalx.Length < 60000) Or (j = False)) And (Finalx.Length < 65000)  'The calculator is 16-bit, so filesizes cannot be larger than 65000. Quit as soon as we reach 60000, or when J is True (meaning that the last byte of the file is not split (like $AA,$A?)) - read on for clarification on J
                'The sound for Guitar Calculator is 2-bit, so I am going to squish 4 bytes of information into 1 byte for the calculator
                Dim Temp = 0
                For l = 0 To 3  'Get 4 bytes (A/B/C/D)
                    Temp += Math.Floor(WaveFile(DataStart + k + l) / 64) * (4 ^ l)  'Change each byte into 2 bits (0,1,2,3), and then add it to the byte (DDCCBBAA) is the format of the byte, (in bits)
                Next
                k += 4  'We have just processed 4 bytes of information
                'Evaluate the byte we have just made.
                Select Case CompressedType(Temp)
                    Case 1  'If it's type 1 compression (compress it into 4 bits)
                        Select Case Temp
                            Case 170    'If the byte is this value,
                                AddNibble(Finalx, j, 0) 'Add "0" as a nibble of information (4 bits)
                            Case 85
                                AddNibble(Finalx, j, 1)
                            Case 255
                                AddNibble(Finalx, j, 2)
                            Case 0
                                AddNibble(Finalx, j, 3)
                            Case 90
                                AddNibble(Finalx, j, 4)
                            Case 106
                                AddNibble(Finalx, j, 5)
                            Case 165
                                AddNibble(Finalx, j, 6)
                            Case 169
                                AddNibble(Finalx, j, 7)
                            Case 86
                                AddNibble(Finalx, j, 8)
                            Case 149
                                AddNibble(Finalx, j, 9)
                            Case 150
                                AddNibble(Finalx, j, 10)
                        End Select
                    Case 2 'If it's type 2 compression (compress it into 8 bits) - note that the value of the actual byte and its "compressed" state are not the same values
                        Select Case Temp
                            Case 105
                                AddNibble(Finalx, j, &HB)   'Add "B"
                                AddNibble(Finalx, j, &H0)   'Add "0" -> Equivilant to adding the byte "$B0" - but This may be cut in half (like $AA, $AB, $0A, $AA)
                            Case 154
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H1)
                            Case 166
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H2)
                            Case 89
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H3)
                            Case 101
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H4)
                            Case 171
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H5)
                            Case 21
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H6)
                            Case 84
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H7)
                            Case 234
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H8)
                            Case 5
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &H9)
                            Case 175
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &HA)
                            Case 80
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &HB)
                            Case 250
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &HC)
                            Case 1
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &HD)
                            Case 64
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &HE)
                            Case 191
                                AddNibble(Finalx, j, &HB)
                                AddNibble(Finalx, j, &HF)
                            Case 254
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H0)
                            Case 174
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H1)
                            Case 81
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H2)
                            Case 69
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H3)
                            Case 186
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H4)
                            Case 65
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H5)
                            Case 190
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H6)
                            Case 102
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H7)
                            Case 153
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H8)
                            Case 20
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &H9)
                            Case 235
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &HA)
                            Case 26
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &HB)
                            Case 164
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &HC)
                            Case 16
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &HD)
                            Case 229
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &HE)
                            Case 4
                                AddNibble(Finalx, j, &HC)
                                AddNibble(Finalx, j, &HF)
                            Case 70
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H0)
                            Case 144
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H1)
                            Case 239
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H2)
                            Case 251
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H3)
                            Case 6
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H4)
                            Case 185
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H5)
                            Case 145
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H6)
                            Case 249
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H7)
                            Case 91
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H8)
                            Case 111
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &H9)
                            Case 110
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &HA)
                            Case 22
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &HB)
                            Case 148
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &HC)
                            Case 107
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &HD)
                            Case 233
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &HE)
                            Case 100
                                AddNibble(Finalx, j, &HD)
                                AddNibble(Finalx, j, &HF)
                            Case 25
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H0)
                            Case 155
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H1)
                            Case 230
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H2)
                            Case 17
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H3)
                            Case 68
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H4)
                            Case 187
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H5)
                            Case 238
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H6)
                            Case 10
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H7)
                            Case 160
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H8)
                            Case 66
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &H9)
                            Case 245
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &HA)
                            Case 189
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &HB)
                            Case 129
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &HC)
                            Case 104
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &HD)
                            Case 27
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &HE)
                            Case 228
                                AddNibble(Finalx, j, &HE)
                                AddNibble(Finalx, j, &HF)
                        End Select
                    Case 3  'If it's type 3 compression (compress it into 12 bits)
                        AddNibble(Finalx, j, &HF)   'Add "F" (identifying it as type 3 compression
                        AddNibble(Finalx, j, Math.Floor(Temp / 16)) 'Add the real value of the byte (ms)
                        AddNibble(Finalx, j, Temp Mod 16)           '(ls)
                End Select
                If (k + 3 >= DataSize) Then 'Stop making the AppVar if we are at the end of the song (or within 3 bytes - since we process 4 at a time)
                    Exit While
                End If
            End While
            CreateApp(Finalx, Named2 + Chr(Asc("A") - 1 + i), Named)    'Create an AppVar called Named2+Letter (as the filename, for AppVar.8xv file)
            '                                                           Named is the char array to input inside the file as data for the AppVar itself
            If (k + 3 >= DataSize) Then 'Don't forget to leave the infinite while loop
                Exit While
            End If
            'We loop again if we quit the inner while loop because the ApPVar reached 60000 in size
        End While
        Finala(&H5C) = i    'We are back to Finala - creating the informative file. $5C tells how many song files there are
        'We will loop 4 times to ask the user for Easy/Medium/Hard/Expert difficulties (the notes in the song)
        For l = 0 To 3
            Select Case l   'Determine which difficulty we are talking about
                Case 0
                    TempResponse = "Easy".ToCharArray
                Case 1
                    TempResponse = "Medium".ToCharArray
                Case 2
                    TempResponse = "Hard".ToCharArray
                Case 3
                    TempResponse = "Expert".ToCharArray
            End Select
            Named(7) = Chr(l + Asc("1"))    'Number the file 1,2,3,4 accordingly
            For i = 0 To TempResponse.GetUpperBound(0)  'Write the difficulty in the file
                Finala(44 + i) = Asc(TempResponse(i))
            Next
            While i < 6
                Finala(44 + i) = Asc(" ")   'Pad the end with spaces (for "Easy" and "Hard")
                i += 1
            End While

            Dim ButtonInfo = InputBox("Please paste the button info in here for " + TempResponse)   'Ask for the button info
            i = 0
            Dim Finalc = Finala.Clone() 'Save a copy of the informative file before we add the information about the notes that is specific to 1 difficulty
            While (i < ButtonInfo.Length)   'If we are not at the end of the pasted info, it means that the user is telling us what the next note is. Add 3 bytes to accommodate this new information
                ReDim Preserve Finala(Finala.GetUpperBound(0) + 3)
                j = ButtonInfo.IndexOf(";", i)
                k = CInt(ButtonInfo.Substring(i, j - i))    'Get the value of the first number (from the current position until the next semi-colon). This is the timestamp at which the note is played (modulated at 65536 by the user - so it fits into 2 bytes)
                Finala(Finala.GetUpperBound(0) - 2) = (k) Mod (256) 'put the lsb into the file
                Finala(Finala.GetUpperBound(0) - 1) = Math.Floor(k / 256) 'put the msb into the file
                i = j + 1   'Move past the semicolon in the inputted string
                j = ButtonInfo.IndexOf(";", i)
                k = CInt(ButtonInfo.Substring(i, j - i))    'Get the value of the second number, which is between 0 and 255 (which represents which note the user must hit)
                Finala(Finala.GetUpperBound(0)) = k 'Store it in the file
                i = j + 1
                'Loop again to get the next note
            End While
            CreateApp(Finala, Named2 + Chr(l + Asc("1")), Named)    'Create the AppVar for the informative file
            Finala = Finalc 'Restore the old array before adding all those notes
        Next

        MsgBox("Complete!") 'Finished!
        Me.Close()
    End Sub
    Sub AddNibble(ByRef Finalxx, ByRef FullByte, ByVal Adding)  'Finalxx and FullByte (the array and j) are referenced ByRef, meaning I can change their values (and this will be reflected in my main code)
        If (FullByte = True) Then   'If the last byte is complete
            FullByte = False
            ReDim Preserve Finalxx(Finalxx.Length)    'Add another byte
            Finalxx(Finalxx.GetUpperBound(0)) = Adding * 16 'In the msb, add the nibble of information
        Else
            FullByte = True 'If it isn't
            Finalxx(Finalxx.GetUpperBound(0)) += Adding 'In the lsb, add the nibble of information
        End If

    End Sub
    Function CreateApp(ByVal Finala(), ByVal Named2, ByVal Named)
        Dim BO
        BO = New ClsBin 'To deal with the problem with 0-value bytes
        Dim i
        Dim Finalb(71 + 2 + Finala.Length + 2)  'We are adding the information around the AppVar that is present in the file on the computer
        'PreDeffed is what the header in the file looks like. We will stick this at the beginning of the file.
        Dim PreDeffed As Byte() = New Byte(71) {&H2A, &H2A, &H54, &H49, &H38, &H33, &H46, &H2A, &H1A, &HA, &H0, &H47, &H75, &H69, &H74, &H61, &H72, &H20, &H43, &H61, &H6C, &H63, &H75, &H6C, &H61, &H74, &H6F, &H72, &H20, &H62, &H79, &H20, &H53, &H65, &H72, &H65, &H6E, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &HFE, &HFE, &HD, &H0, &HFE, &HFE, &H15, &H5B, &H59, &H20, &H4E, &H41, &H4D, &H45, &H21, &H0, &H80, &HFE, &HFE}
        For g = 0 To 71
            Finalb(g) = PreDeffed(g)
        Next

        For i = 0 To Named.GetUpperBound(0) 'We will also stick the name of the AppVar where it belongs (there is a placeholder in PreDeffed)
            Finalb(&H3C + i) = Asc(Named2(i))
        Next
        While (i <= 8)
            Finalb(&H3C + i) = 0    'Wow, looks like I did deal with padding the AppVar if it wasn't 8 characters long. Oh well.
            i += 1
        End While

        Finalb(&H35) = (&H11 + Finala.Length + 2) Mod 256
        Finalb(&H36) = Math.Floor((&H11 + Finala.Length + 2) / 256) 'These 2 bytes say how long the rest of the file is - I must calculate this based on the size of the AppVar
        Finalb(&H39) = (Finala.Length + 2) Mod 256
        Finalb(&H3A) = Math.Floor((Finala.Length + 2) / 256)    'These two bytes do pretty much the same thing
        Finalb(&H46) = Finalb(&H39) 'These bytes are equivilant to $39 and $3A, yippie.
        Finalb(&H47) = Finalb(&H3A)

        Finalb(&H48) = (Finala.Length) Mod 256  '&H48 is the first byte of the actual AppVar. The first two bytes in an AppVar describe its length. Stick it in.
        Finalb(&H49) = Math.Floor((Finala.Length) / 256)
        For i = 0 To Finala.Length - 1
            Finalb(&H4A + i) = Finala(i)    'Copy the rest of the AppVar in after it.
        Next
        'Checksum
        i = 0
        For j = &H37 To &H37 + &H11 + Finala.Length + 2 - 1 'The last 2 bytes in the file are a checksum of all the bytes from $37 to the end (excluding the checksum itself)
            i += Finalb(j)
        Next
        i = i Mod (256 * 256)   'The checksum is the sum of all the bytes, modulated into 16 bits. So we will modulate it by 2^16
        Finalb(&H37 + &H11 + Finala.Length + 2) = i Mod 256 'Stick the checksum into the last to bytes of the file.
        Finalb(&H37 + &H11 + Finala.Length + 2 + 1) = Math.Floor(i / 256)
        BO.WriteFileA(Named2 + ".8xv", Finalb)  'Make the actual file on the computer using the Class that also deals with the $00 problem.
        Return 1
    End Function

    Class ClsBin    'This is the class that deals with the $00 byte problem, and also conveniently reads/writes files for me.
        Private i, TS, sAst, ANums, Char1

        Private Sub Class_Initialize()
            sAst = "*"
            Char1 = Chr(1)
            'FSO2 = CreateObject("Scripting.FileSystemObject")
        End Sub

        Private Sub Class_Terminate()
            TS = Nothing
            'FSO = Nothing
        End Sub

        Public Function GetSize(ByVal sFilePath)
            Dim OFil, FSO2
            FSO2 = CreateObject("Scripting.FileSystemObject")
            OFil = FSO2.GetFile(sFilePath)
            GetSize = OFil.Size
            OFil = Nothing
        End Function

        'Public Function Read(ByVal sFilePath)
        '    Dim LenR
        '    On Error Resume Next
        '    Read = ""
        '    TS = FSO.OpenTextFile(sFilePath, 1)
        '    Read = TS.Read(GetSize(sFilePath))
        '    TS.Close()
        '    TS = Nothing
        'End Function
        Public Function Read(ByVal sFilePath)
            Dim LenF, StartPt, LenR, FSO2
            FSO2 = CreateObject("Scripting.FileSystemObject")
            StartPt = 0
            LenR = 0
            'On Error Resume Next
            Read = ""
            If (FSO2.FileExists(sFilePath) = False) Then Exit Function
            LenF = GetSize(sFilePath)
            If (StartPt >= LenF) Then Exit Function
            If (StartPt < 1) Then StartPt = 1
            If (LenR = 0) Then LenR = LenF
            TS = FSO2.OpenTextFile(sFilePath, 1)
            If (StartPt > 1) Then TS.Skip(StartPt - 1)
            Read = TS.Read(LenR)
            TS.Close()
            TS = Nothing
        End Function

        Public Function WriteFileA(ByVal sFilePath, ByVal ArrayIn)
            Dim sA1, iA1, FSO2
            FSO2 = CreateObject("Scripting.FileSystemObject")
            On Error Resume Next
            FSO2.DeleteFile(sFilePath, True)
            Err.Clear()
            For iA1 = 0 To UBound(ArrayIn)
                ArrayIn(iA1) = Chr(ArrayIn(iA1))
            Next
            sA1 = Join(ArrayIn, "")

            TS = FSO2.CreateTextFile(sFilePath, True)
            TS.Write(sA1)
            TS.Close()
            TS = Nothing
            WriteFileA = Err.Number
        End Function


        Function GetArray(ByVal sStr)
            Dim iA, Len1, AStr()
            On Error Resume Next
            Len1 = Len(sStr)
            ReDim AStr(Len1 - 1)
            For iA = 1 To Len(sStr)
                AStr(iA - 1) = Asc(Mid(sStr, iA, 1))
            Next
            GetArray = AStr
        End Function

    End Class
End Class
